| AI Engine-ML Intrinsics User Guide (v2026.1)

Loading...
Searching...
No Matches
Stream write
Load/Store Operations » Streams

## Overview

## Packet headers
These intrinsics are designed to facilitate the headers creation. They write directly to a stream
void | put_ms_packet_header (int tlast, unsigned dstID, unsigned pcktType)
| Generate a packet header and write to it to the output stream port.
void | put_ms_packet_header (unsigned dstID, unsigned pcktType)
| Generate a packet header and write to it to the output stream port.
void | put_ms_nb_packet_header (int tlast, unsigned dstID, unsigned pcktType, bool &success)
| Generate a packet header and write to it to the output stream port.
void | put_ms_nb_packet_header (unsigned dstID, unsigned pcktType, bool &success)
| Generate a packet header and write to it to the output stream port.
void | put_ms_ctrl_packet_header (int tlast, unsigned Addr, unsigned n_words, unsigned op_type, unsigned rspID)
| Generate a control packet header and write it to the output stream port.
void | put_ms_ctrl_packet_header (unsigned Addr, unsigned n_words, unsigned op_type, unsigned rspID)
| Generate a control packet header and write it to the output stream port.
void | put_ms_nb_ctrl_packet_header (int tlast, unsigned Addr, unsigned n_words, unsigned op_type, unsigned rspID, bool &success)
| Generate a control packet header and write it to the output stream port.
void | put_ms_nb_ctrl_packet_header (unsigned Addr, unsigned n_words, unsigned op_type, unsigned rspID, bool &success)
| Generate a control packet header and write it to the output stream port.

## Packet headers (deprecated)
These intrinsics are designed to facilitate the headers creation. They do not write directly to a stream and should always be combined with a "put_ms" call.
unsigned int | packet_header (unsigned dstID, unsigned pcktType)
| Generate a packet header.
unsigned int | ctrl_packet_header (unsigned Addr, unsigned n_words, unsigned op_type, unsigned rspID)
| Generate a control packet header.

## Write Single word to 32-bit streams
void | put_ms (int val)
| Write a 32-bit value to the output stream port.
void | put_ms (int val, int tlast)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (int val, int tlast, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (int val, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms (int val, int en, int tlast)
| Write a 32-bit value to the output stream port.
void | put_ms (unsigned int val)
| Write a 32-bit value to the output stream port.
void | put_ms (unsigned int val, int tlast)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (unsigned int val, int tlast, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (unsigned int val, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms (unsigned int val, int en, int tlast)
| Write a 32-bit value to the output stream port.
void | put_ms (float val)
| Write a 32-bit value to the output stream port.
void | put_ms (float val, int tlast)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (float val, int tlast, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (float val, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms (float val, int en, int tlast)
| Write a 32-bit value to the output stream port.
void | put_ms (v8int4 val)
| Write a 32-bit value to the output stream port.
void | put_ms (v8int4 val, int tlast)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v8int4 val, int tlast, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v8int4 val, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms (v8int4 val, int en, int tlast)
| Write a 32-bit value to the output stream port.
void | put_ms (v8uint4 val)
| Write a 32-bit value to the output stream port.
void | put_ms (v8uint4 val, int tlast)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v8uint4 val, int tlast, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v8uint4 val, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms (v8uint4 val, int en, int tlast)
| Write a 32-bit value to the output stream port.
void | put_ms (v4int8 val)
| Write a 32-bit value to the output stream port.
void | put_ms (v4int8 val, int tlast)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v4int8 val, int tlast, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v4int8 val, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms (v4int8 val, int en, int tlast)
| Write a 32-bit value to the output stream port.
void | put_ms (v4uint8 val)
| Write a 32-bit value to the output stream port.
void | put_ms (v4uint8 val, int tlast)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v4uint8 val, int tlast, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v4uint8 val, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms (v4uint8 val, int en, int tlast)
| Write a 32-bit value to the output stream port.
void | put_ms (v2int16 val)
| Write a 32-bit value to the output stream port.
void | put_ms (v2int16 val, int tlast)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v2int16 val, int tlast, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v2int16 val, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms (v2int16 val, int en, int tlast)
| Write a 32-bit value to the output stream port.
void | put_ms (v2uint16 val)
| Write a 32-bit value to the output stream port.
void | put_ms (v2uint16 val, int tlast)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v2uint16 val, int tlast, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v2uint16 val, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms (v2uint16 val, int en, int tlast)
| Write a 32-bit value to the output stream port.
void | put_ms (cint16 val)
| Write a 32-bit value to the output stream port.
void | put_ms (cint16 val, int tlast)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (cint16 val, int tlast, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (cint16 val, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms (cint16 val, int en, int tlast)
| Write a 32-bit value to the output stream port.
void | put_ms (v2bfloat16 val)
| Write a 32-bit value to the output stream port.
void | put_ms (v2bfloat16 val, int tlast)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v2bfloat16 val, int tlast, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms_nb (v2bfloat16 val, bool &success)
| Write a 32-bit value to the output stream port. Non-blocking read.
void | put_ms (v2bfloat16 val, int en, int tlast)
| Write a 32-bit value to the output stream port.

## Write 128-bit vector to 32-bit streams
void | put_ms (v4int32 a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v4int32 a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v32int4 a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v32int4 a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v32uint4 a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v32uint4 a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v16int8 a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v16int8 a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v16uint8 a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v16uint8 a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v8int16 a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v8int16 a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v8uint16 a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v8uint16 a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v4cint16 a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v4cint16 a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v4uint32 a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v4uint32 a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v2cint32 a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v2cint32 a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v2cfloat a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v2cfloat a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v8bfloat16 a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v8bfloat16 a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v4cbfloat16 a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v4cbfloat16 a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v4float a, int tlast)
| Write a 128-bit vector value to the output stream port.
void | put_ms (v4float a, int en, int tlast)
| Write a 128-bit vector value to the output stream port.

## Write 256-bit vector to 32-bit streams
void | put_ms (v8int32 a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v8int32 a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v64int4 a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v64int4 a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v64uint4 a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v64uint4 a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v32int8 a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v32int8 a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v32uint8 a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v32uint8 a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v16int16 a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v16int16 a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v16uint16 a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v16uint16 a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v8cint16 a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v8cint16 a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v8uint32 a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v8uint32 a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v4cint32 a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v4cint32 a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v4cfloat a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v4cfloat a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v16bfloat16 a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v16bfloat16 a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v8cbfloat16 a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v8cbfloat16 a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v8float a, int tlast)
| Write a 256-bit vector value to the output stream port.
void | put_ms (v8float a, int en, int tlast)
| Write a 256-bit vector value to the output stream port.

## Write 512-bit vector to 32-bit streams
void | put_ms (v16int32 a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v16int32 a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v128int4 a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v128int4 a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v128uint4 a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v128uint4 a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v64int8 a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v64int8 a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v64uint8 a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v64uint8 a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v32int16 a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v32int16 a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v32uint16 a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v32uint16 a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v16cint16 a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v16cint16 a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v16uint32 a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v16uint32 a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v8cint32 a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v8cint32 a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v8cfloat a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v8cfloat a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v32bfloat16 a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v32bfloat16 a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v16cbfloat16 a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v16cbfloat16 a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v16float a, int tlast)
| Write a 512-bit vector value to the output stream port.
void | put_ms (v16float a, int en, int tlast)
| Write a 512-bit vector value to the output stream port.

## Write 1024-bit vector to 32-bit streams
void | put_ms (v32int32 a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v32int32 a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v256int4 a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v256int4 a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v256uint4 a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v256uint4 a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v128int8 a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v128int8 a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v128uint8 a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v128uint8 a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v64int16 a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v64int16 a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v64uint16 a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v64uint16 a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v32cint16 a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v32cint16 a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v32uint32 a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v32uint32 a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v16cint32 a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v16cint32 a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v16cfloat a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v16cfloat a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v64bfloat16 a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v64bfloat16 a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v32cbfloat16 a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v32cbfloat16 a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v32float a, int tlast)
| Write a 1024-bit vector value to the output stream port.
void | put_ms (v32float a, int en, int tlast)
| Write a 1024-bit vector value to the output stream port.

## Function Documentation

## ◆ ctrl_packet_header()

unsigned int ctrl_packet_header | ( | unsigned | Addr,
|  | unsigned | n_words,
|  | unsigned | op_type,
|  | unsigned | rspID )

Generate a control packet header.

Parameters

  Addr | unsigned Local Byte Address (two LSB not used). Accesses are 128 bit aligned.
  n_words | unsigned 2 bits. 1 to 4 words of 32 bit data to follow. This must be a compile time constant.
  op_type | unsigned Operation modes - 2 bit (LSB). 3 modes. 0 - Write without return, 1 - Read with return, 2 - Write with return. The response to a read will be a packet switched stream header and 1 to 4 32 bit word data. The response to a write will be a packet switched stream header. This must be a compile time constant.
  rspID | unsigned Response ID: 5 bit (LSB). Identifies the return destination for operation modes with a return. (The return packet's header's 'dstID' is set to this).

This intrinsic takes an address, number of words, operation type and response ID and returns a control packet header.

Note
  Parameters 'n_words' and 'op_type' must be compile time constants.

## ◆ packet_header()

unsigned int packet_header | ( | unsigned | dstID,
|  | unsigned | pcktType )

Generate a packet header.

Parameters

  dstID | unsigned 5 bit (LSB). Identifies the destination of the packet. Should be unique amongst all streams it shares ports with. Can be 32 destinations or more with nested headers.
  pcktType | unsigned 3 bit (LSB). Can be used to distinguish packets with the same source and destination. Control packets set this to 7 if there is an error. This must be a compile time constant.

This intrinsic takes a destination ID and a packet type and returns a packet header.

Note
  Parameter 'pcktType' must be a compile time constant.
  A packet with nested headers has a number of headers at the beginning (instead of the usual single header). For every level of header nesting, the number of possible destinations is multiplied by 32, thus for a two-nested header approach, the number of destinations is already 1024.

## ◆ put_ms() [1/145]

void put_ms | ( | cint16 | val | ) |

Write a 32-bit value to the output stream port.

## ◆ put_ms() [2/145]

void put_ms | ( | cint16 | val,
|  | int | en,
|  | int | tlast )

Write a 32-bit value to the output stream port.

Parameters

  val | 32-bit value datatype
  en | Enable input
  tlast | Success of transfer.

## ◆ put_ms() [3/145]

void put_ms | ( | cint16 | val,
|  | int | tlast )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | Last word in a packet and the default is fals

## ◆ put_ms() [4/145]

void put_ms | ( | float | val | ) |

Write a 32-bit value to the output stream port.

## ◆ put_ms() [5/145]

void put_ms | ( | float | val,
|  | int | en,
|  | int | tlast )

Write a 32-bit value to the output stream port.

Parameters

  val | 32-bit value datatype
  en | Enable input
  tlast | Success of transfer.

## ◆ put_ms() [6/145]

void put_ms | ( | float | val,
|  | int | tlast )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | Last word in a packet and the default is fals

## ◆ put_ms() [7/145]

void put_ms | ( | int | val | ) |

Write a 32-bit value to the output stream port.

## ◆ put_ms() [8/145]

void put_ms | ( | int | val,
|  | int | en,
|  | int | tlast )

Write a 32-bit value to the output stream port.

Parameters

  val | 32-bit value datatype
  en | Enable input
  tlast | Success of transfer.

## ◆ put_ms() [9/145]

void put_ms | ( | int | val,
|  | int | tlast )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | Last word in a packet and the default is fals

## ◆ put_ms() [10/145]

void put_ms | ( | unsigned int | val | ) |

Write a 32-bit value to the output stream port.

## ◆ put_ms() [11/145]

void put_ms | ( | unsigned int | val,
|  | int | en,
|  | int | tlast )

Write a 32-bit value to the output stream port.

Parameters

  val | 32-bit value datatype
  en | Enable input
  tlast | Success of transfer.

## ◆ put_ms() [12/145]

void put_ms | ( | unsigned int | val,
|  | int | tlast )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | Last word in a packet and the default is fals

## ◆ put_ms() [13/145]

void put_ms | ( | v128int4 | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [14/145]

void put_ms | ( | v128int4 | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [15/145]

void put_ms | ( | v128int8 | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [16/145]

void put_ms | ( | v128int8 | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [17/145]

void put_ms | ( | v128uint4 | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [18/145]

void put_ms | ( | v128uint4 | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [19/145]

void put_ms | ( | v128uint8 | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [20/145]

void put_ms | ( | v128uint8 | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [21/145]

void put_ms | ( | v16bfloat16 | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [22/145]

void put_ms | ( | v16bfloat16 | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [23/145]

void put_ms | ( | v16cbfloat16 | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [24/145]

void put_ms | ( | v16cbfloat16 | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [25/145]

void put_ms | ( | v16cfloat | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [26/145]

void put_ms | ( | v16cfloat | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [27/145]

void put_ms | ( | v16cint16 | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [28/145]

void put_ms | ( | v16cint16 | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [29/145]

void put_ms | ( | v16cint32 | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [30/145]

void put_ms | ( | v16cint32 | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [31/145]

void put_ms | ( | v16float | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [32/145]

void put_ms | ( | v16float | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [33/145]

void put_ms | ( | v16int16 | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [34/145]

void put_ms | ( | v16int16 | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [35/145]

void put_ms | ( | v16int32 | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [36/145]

void put_ms | ( | v16int32 | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [37/145]

void put_ms | ( | v16int8 | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [38/145]

void put_ms | ( | v16int8 | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [39/145]

void put_ms | ( | v16uint16 | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [40/145]

void put_ms | ( | v16uint16 | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [41/145]

void put_ms | ( | v16uint32 | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [42/145]

void put_ms | ( | v16uint32 | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [43/145]

void put_ms | ( | v16uint8 | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [44/145]

void put_ms | ( | v16uint8 | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [45/145]

void put_ms | ( | v256int4 | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [46/145]

void put_ms | ( | v256int4 | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [47/145]

void put_ms | ( | v256uint4 | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [48/145]

void put_ms | ( | v256uint4 | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [49/145]

void put_ms | ( | v2bfloat16 | val | ) |

Write a 32-bit value to the output stream port.

## ◆ put_ms() [50/145]

void put_ms | ( | v2bfloat16 | val,
|  | int | en,
|  | int | tlast )

Write a 32-bit value to the output stream port.

Parameters

  val | 32-bit value datatype
  en | Enable input
  tlast | Success of transfer.

## ◆ put_ms() [51/145]

void put_ms | ( | v2bfloat16 | val,
|  | int | tlast )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | Last word in a packet and the default is fals

## ◆ put_ms() [52/145]

void put_ms | ( | v2cfloat | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [53/145]

void put_ms | ( | v2cfloat | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [54/145]

void put_ms | ( | v2cint32 | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [55/145]

void put_ms | ( | v2cint32 | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [56/145]

void put_ms | ( | v2int16 | val | ) |

Write a 32-bit value to the output stream port.

## ◆ put_ms() [57/145]

void put_ms | ( | v2int16 | val,
|  | int | en,
|  | int | tlast )

Write a 32-bit value to the output stream port.

Parameters

  val | 32-bit value datatype
  en | Enable input
  tlast | Success of transfer.

## ◆ put_ms() [58/145]

void put_ms | ( | v2int16 | val,
|  | int | tlast )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | Last word in a packet and the default is fals

## ◆ put_ms() [59/145]

void put_ms | ( | v2uint16 | val | ) |

Write a 32-bit value to the output stream port.

## ◆ put_ms() [60/145]

void put_ms | ( | v2uint16 | val,
|  | int | en,
|  | int | tlast )

Write a 32-bit value to the output stream port.

Parameters

  val | 32-bit value datatype
  en | Enable input
  tlast | Success of transfer.

## ◆ put_ms() [61/145]

void put_ms | ( | v2uint16 | val,
|  | int | tlast )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | Last word in a packet and the default is fals

## ◆ put_ms() [62/145]

void put_ms | ( | v32bfloat16 | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [63/145]

void put_ms | ( | v32bfloat16 | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [64/145]

void put_ms | ( | v32cbfloat16 | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [65/145]

void put_ms | ( | v32cbfloat16 | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [66/145]

void put_ms | ( | v32cint16 | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [67/145]

void put_ms | ( | v32cint16 | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [68/145]

void put_ms | ( | v32float | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [69/145]

void put_ms | ( | v32float | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [70/145]

void put_ms | ( | v32int16 | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [71/145]

void put_ms | ( | v32int16 | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [72/145]

void put_ms | ( | v32int32 | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [73/145]

void put_ms | ( | v32int32 | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [74/145]

void put_ms | ( | v32int4 | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [75/145]

void put_ms | ( | v32int4 | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [76/145]

void put_ms | ( | v32int8 | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [77/145]

void put_ms | ( | v32int8 | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [78/145]

void put_ms | ( | v32uint16 | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [79/145]

void put_ms | ( | v32uint16 | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [80/145]

void put_ms | ( | v32uint32 | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [81/145]

void put_ms | ( | v32uint32 | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [82/145]

void put_ms | ( | v32uint4 | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [83/145]

void put_ms | ( | v32uint4 | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [84/145]

void put_ms | ( | v32uint8 | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [85/145]

void put_ms | ( | v32uint8 | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [86/145]

void put_ms | ( | v4cbfloat16 | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [87/145]

void put_ms | ( | v4cbfloat16 | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [88/145]

void put_ms | ( | v4cfloat | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [89/145]

void put_ms | ( | v4cfloat | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [90/145]

void put_ms | ( | v4cint16 | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [91/145]

void put_ms | ( | v4cint16 | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [92/145]

void put_ms | ( | v4cint32 | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [93/145]

void put_ms | ( | v4cint32 | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [94/145]

void put_ms | ( | v4float | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [95/145]

void put_ms | ( | v4float | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [96/145]

void put_ms | ( | v4int32 | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [97/145]

void put_ms | ( | v4int32 | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [98/145]

void put_ms | ( | v4int8 | val | ) |

Write a 32-bit value to the output stream port.

## ◆ put_ms() [99/145]

void put_ms | ( | v4int8 | val,
|  | int | en,
|  | int | tlast )

Write a 32-bit value to the output stream port.

Parameters

  val | 32-bit value datatype
  en | Enable input
  tlast | Success of transfer.

## ◆ put_ms() [100/145]

void put_ms | ( | v4int8 | val,
|  | int | tlast )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | Last word in a packet and the default is fals

## ◆ put_ms() [101/145]

void put_ms | ( | v4uint32 | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [102/145]

void put_ms | ( | v4uint32 | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [103/145]

void put_ms | ( | v4uint8 | val | ) |

Write a 32-bit value to the output stream port.

## ◆ put_ms() [104/145]

void put_ms | ( | v4uint8 | val,
|  | int | en,
|  | int | tlast )

Write a 32-bit value to the output stream port.

Parameters

  val | 32-bit value datatype
  en | Enable input
  tlast | Success of transfer.

## ◆ put_ms() [105/145]

void put_ms | ( | v4uint8 | val,
|  | int | tlast )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | Last word in a packet and the default is fals

## ◆ put_ms() [106/145]

void put_ms | ( | v64bfloat16 | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [107/145]

void put_ms | ( | v64bfloat16 | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [108/145]

void put_ms | ( | v64int16 | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [109/145]

void put_ms | ( | v64int16 | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [110/145]

void put_ms | ( | v64int4 | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [111/145]

void put_ms | ( | v64int4 | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [112/145]

void put_ms | ( | v64int8 | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [113/145]

void put_ms | ( | v64int8 | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [114/145]

void put_ms | ( | v64uint16 | a,
|  | int | en,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [115/145]

void put_ms | ( | v64uint16 | a,
|  | int | tlast )

Write a 1024-bit vector value to the output stream port.

Parameters

  a | 1024-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [116/145]

void put_ms | ( | v64uint4 | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [117/145]

void put_ms | ( | v64uint4 | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [118/145]

void put_ms | ( | v64uint8 | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [119/145]

void put_ms | ( | v64uint8 | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [120/145]

void put_ms | ( | v8bfloat16 | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [121/145]

void put_ms | ( | v8bfloat16 | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [122/145]

void put_ms | ( | v8cbfloat16 | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [123/145]

void put_ms | ( | v8cbfloat16 | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [124/145]

void put_ms | ( | v8cfloat | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [125/145]

void put_ms | ( | v8cfloat | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [126/145]

void put_ms | ( | v8cint16 | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [127/145]

void put_ms | ( | v8cint16 | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [128/145]

void put_ms | ( | v8cint32 | a,
|  | int | en,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [129/145]

void put_ms | ( | v8cint32 | a,
|  | int | tlast )

Write a 512-bit vector value to the output stream port.

Parameters

  a | 512-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [130/145]

void put_ms | ( | v8float | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [131/145]

void put_ms | ( | v8float | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [132/145]

void put_ms | ( | v8int16 | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [133/145]

void put_ms | ( | v8int16 | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [134/145]

void put_ms | ( | v8int32 | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [135/145]

void put_ms | ( | v8int32 | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [136/145]

void put_ms | ( | v8int4 | val | ) |

Write a 32-bit value to the output stream port.

## ◆ put_ms() [137/145]

void put_ms | ( | v8int4 | val,
|  | int | en,
|  | int | tlast )

Write a 32-bit value to the output stream port.

Parameters

  val | 32-bit value datatype
  en | Enable input
  tlast | Success of transfer.

## ◆ put_ms() [138/145]

void put_ms | ( | v8int4 | val,
|  | int | tlast )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | Last word in a packet and the default is fals

## ◆ put_ms() [139/145]

void put_ms | ( | v8uint16 | a,
|  | int | en,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [140/145]

void put_ms | ( | v8uint16 | a,
|  | int | tlast )

Write a 128-bit vector value to the output stream port.

Parameters

  a | 128-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [141/145]

void put_ms | ( | v8uint32 | a,
|  | int | en,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  en | Enable input
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [142/145]

void put_ms | ( | v8uint32 | a,
|  | int | tlast )

Write a 256-bit vector value to the output stream port.

Parameters

  a | 256-bit vector
  tlast | Last word in a packet and the default is false.

## ◆ put_ms() [143/145]

void put_ms | ( | v8uint4 | val | ) |

Write a 32-bit value to the output stream port.

## ◆ put_ms() [144/145]

void put_ms | ( | v8uint4 | val,
|  | int | en,
|  | int | tlast )

Write a 32-bit value to the output stream port.

Parameters

  val | 32-bit value datatype
  en | Enable input
  tlast | Success of transfer.

## ◆ put_ms() [145/145]

void put_ms | ( | v8uint4 | val,
|  | int | tlast )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | Last word in a packet and the default is fals

## ◆ put_ms_ctrl_packet_header() [1/2]

void put_ms_ctrl_packet_header | ( | int | tlast,
|  | unsigned | Addr,
|  | unsigned | n_words,
|  | unsigned | op_type,
|  | unsigned | rspID )

Generate a control packet header and write it to the output stream port.

Parameters

  tlast | tlast
  Addr | unsigned Local Byte Address (two LSB not used). Accesses are 128 bit aligned.
  n_words | unsigned 2 bits. 1 to 4 words of 32 bit data to follow. This must be a compile time constant.
  op_type | unsigned Operation modes - 2 bit (LSB). 3 modes. 0 - Write without return, 1 - Read with return, 2 - Write with return. The response to a read will be a packet switched stream header and 1 to 4 32 bit word data. The response to a write will be a packet switched stream header. This must be a compile time constant.
  rspID | unsigned Response ID: 5 bit (LSB). Identifies the return destination for operation modes with a return. (The return packet's header's 'dstID' is set to this).

This intrinsic takes an address, number of words, operation type and response ID and returns a control packet header.

Note
  Parameters 'n_words' and 'op_type' must be compile time constants.

## ◆ put_ms_ctrl_packet_header() [2/2]

void put_ms_ctrl_packet_header | ( | unsigned | Addr,
|  | unsigned | n_words,
|  | unsigned | op_type,
|  | unsigned | rspID )

Generate a control packet header and write it to the output stream port.

Parameters

  Addr | unsigned Local Byte Address (two LSB not used). Accesses are 128 bit aligned.
  n_words | unsigned 2 bits. 1 to 4 words of 32 bit data to follow. This must be a compile time constant.
  op_type | unsigned Operation modes - 2 bit (LSB). 3 modes. 0 - Write without return, 1 - Read with return, 2 - Write with return. The response to a read will be a packet switched stream header and 1 to 4 32 bit word data. The response to a write will be a packet switched stream header. This must be a compile time constant.
  rspID | unsigned Response ID: 5 bit (LSB). Identifies the return destination for operation modes with a return. (The return packet's header's 'dstID' is set to this).

This intrinsic takes an address, number of words, operation type and response ID and returns a control packet header.

Note
  Parameters 'n_words' and 'op_type' must be compile time constants.

## ◆ put_ms_nb() [1/22]

void put_ms_nb | ( | cint16 | val,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  success | Success of transfer.

## ◆ put_ms_nb() [2/22]

void put_ms_nb | ( | cint16 | val,
|  | int | tlast,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | last word in a packet and the default is fals
  success | Success of transfer.

## ◆ put_ms_nb() [3/22]

void put_ms_nb | ( | float | val,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  success | Success of transfer.

## ◆ put_ms_nb() [4/22]

void put_ms_nb | ( | float | val,
|  | int | tlast,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | last word in a packet and the default is fals
  success | Success of transfer.

## ◆ put_ms_nb() [5/22]

void put_ms_nb | ( | int | val,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  success | Success of transfer.

## ◆ put_ms_nb() [6/22]

void put_ms_nb | ( | int | val,
|  | int | tlast,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | last word in a packet and the default is fals
  success | Success of transfer.

## ◆ put_ms_nb() [7/22]

void put_ms_nb | ( | unsigned int | val,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  success | Success of transfer.

## ◆ put_ms_nb() [8/22]

void put_ms_nb | ( | unsigned int | val,
|  | int | tlast,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | last word in a packet and the default is fals
  success | Success of transfer.

## ◆ put_ms_nb() [9/22]

void put_ms_nb | ( | v2bfloat16 | val,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  success | Success of transfer.

## ◆ put_ms_nb() [10/22]

void put_ms_nb | ( | v2bfloat16 | val,
|  | int | tlast,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | last word in a packet and the default is fals
  success | Success of transfer.

## ◆ put_ms_nb() [11/22]

void put_ms_nb | ( | v2int16 | val,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  success | Success of transfer.

## ◆ put_ms_nb() [12/22]

void put_ms_nb | ( | v2int16 | val,
|  | int | tlast,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | last word in a packet and the default is fals
  success | Success of transfer.

## ◆ put_ms_nb() [13/22]

void put_ms_nb | ( | v2uint16 | val,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  success | Success of transfer.

## ◆ put_ms_nb() [14/22]

void put_ms_nb | ( | v2uint16 | val,
|  | int | tlast,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | last word in a packet and the default is fals
  success | Success of transfer.

## ◆ put_ms_nb() [15/22]

void put_ms_nb | ( | v4int8 | val,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  success | Success of transfer.

## ◆ put_ms_nb() [16/22]

void put_ms_nb | ( | v4int8 | val,
|  | int | tlast,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | last word in a packet and the default is fals
  success | Success of transfer.

## ◆ put_ms_nb() [17/22]

void put_ms_nb | ( | v4uint8 | val,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  success | Success of transfer.

## ◆ put_ms_nb() [18/22]

void put_ms_nb | ( | v4uint8 | val,
|  | int | tlast,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | last word in a packet and the default is fals
  success | Success of transfer.

## ◆ put_ms_nb() [19/22]

void put_ms_nb | ( | v8int4 | val,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  success | Success of transfer.

## ◆ put_ms_nb() [20/22]

void put_ms_nb | ( | v8int4 | val,
|  | int | tlast,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | last word in a packet and the default is fals
  success | Success of transfer.

## ◆ put_ms_nb() [21/22]

void put_ms_nb | ( | v8uint4 | val,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  success | Success of transfer.

## ◆ put_ms_nb() [22/22]

void put_ms_nb | ( | v8uint4 | val,
|  | int | tlast,
|  | bool & | success )

Write a 32-bit value to the output stream port. Non-blocking read.

Parameters

  val | 32-bit value datatype
  tlast | last word in a packet and the default is fals
  success | Success of transfer.

## ◆ put_ms_nb_ctrl_packet_header() [1/2]

void put_ms_nb_ctrl_packet_header | ( | int | tlast,
|  | unsigned | Addr,
|  | unsigned | n_words,
|  | unsigned | op_type,
|  | unsigned | rspID,
|  | bool & | success )

Generate a control packet header and write it to the output stream port.

Parameters

  tlast | tlast
  Addr | unsigned Local Byte Address (two LSB not used). Accesses are 128 bit aligned.
  n_words | unsigned 2 bits. 1 to 4 words of 32 bit data to follow. This must be a compile time constant.
  op_type | unsigned Operation modes - 2 bit (LSB). 3 modes. 0 - Write without return, 1 - Read with return, 2 - Write with return. The response to a read will be a packet switched stream header and 1 to 4 32 bit word data. The response to a write will be a packet switched stream header. This must be a compile time constant.
  rspID | unsigned Response ID: 5 bit (LSB). Identifies the return destination for operation modes with a return. (The return packet's header's 'dstID' is set to this).
  success | success of transfer

This intrinsic takes an address, number of words, operation type and response ID and returns a control packet header.

Note
  Parameters 'n_words' and 'op_type' must be compile time constants.

## ◆ put_ms_nb_ctrl_packet_header() [2/2]

void put_ms_nb_ctrl_packet_header | ( | unsigned | Addr,
|  | unsigned | n_words,
|  | unsigned | op_type,
|  | unsigned | rspID,
|  | bool & | success )

Generate a control packet header and write it to the output stream port.

Parameters

  Addr | unsigned Local Byte Address (two LSB not used). Accesses are 128 bit aligned.
  n_words | unsigned 2 bits. 1 to 4 words of 32 bit data to follow. This must be a compile time constant.
  op_type | unsigned Operation modes - 2 bit (LSB). 3 modes. 0 - Write without return, 1 - Read with return, 2 - Write with return. The response to a read will be a packet switched stream header and 1 to 4 32 bit word data. The response to a write will be a packet switched stream header. This must be a compile time constant.
  rspID | unsigned Response ID: 5 bit (LSB). Identifies the return destination for operation modes with a return. (The return packet's header's 'dstID' is set to this).
  success | success of transfer

This intrinsic takes an address, number of words, operation type and response ID and returns a control packet header.

Note
  Parameters 'n_words' and 'op_type' must be compile time constants.

## ◆ put_ms_nb_packet_header() [1/2]

void put_ms_nb_packet_header | ( | int | tlast,
|  | unsigned | dstID,
|  | unsigned | pcktType,
|  | bool & | success )

Generate a packet header and write to it to the output stream port.

Parameters

  tlast | tlast
  dstID | unsigned 5 bit (LSB). Identifies the destination of the packet. Should be unique amongst all streams it shares ports with. Can be 32 destinations or more with nested headers.
  pcktType | unsigned 3 bit (LSB). Can be used to distinguish packets with the same source and destination. Control packets set this to 7 if there is an error. This must be a compile time constant.
  success | success of transfer

This intrinsic takes a destination ID and a packet type and returns a packet header.

Note
  Parameter 'pcktType' must be a compile time constant.
  A packet with nested headers has a number of headers at the beginning (instead of the usual single header). For every level of header nesting, the number of possible destinations is multiplied by 32, thus for a two-nested header approach, the number of destinations is already 1024.

## ◆ put_ms_nb_packet_header() [2/2]

void put_ms_nb_packet_header | ( | unsigned | dstID,
|  | unsigned | pcktType,
|  | bool & | success )

Generate a packet header and write to it to the output stream port.

Parameters

  dstID | unsigned 5 bit (LSB). Identifies the destination of the packet. Should be unique amongst all streams it shares ports with. Can be 32 destinations or more with nested headers.
  pcktType | unsigned 3 bit (LSB). Can be used to distinguish packets with the same source and destination. Control packets set this to 7 if there is an error. This must be a compile time constant.
  success | success of transfer

This intrinsic takes a destination ID and a packet type and returns a packet header.

Note
  Parameter 'pcktType' must be a compile time constant.
  A packet with nested headers has a number of headers at the beginning (instead of the usual single header). For every level of header nesting, the number of possible destinations is multiplied by 32, thus for a two-nested header approach, the number of destinations is already 1024.

## ◆ put_ms_packet_header() [1/2]

void put_ms_packet_header | ( | int | tlast,
|  | unsigned | dstID,
|  | unsigned | pcktType )

Generate a packet header and write to it to the output stream port.

Parameters

  tlast | tlast
  dstID | unsigned 5 bit (LSB). Identifies the destination of the packet. Should be unique amongst all streams it shares ports with. Can be 32 destinations or more with nested headers.
  pcktType | unsigned 3 bit (LSB). Can be used to distinguish packets with the same source and destination. Control packets set this to 7 if there is an error. This must be a compile time constant.

This intrinsic takes a destination ID and a packet type and returns a packet header.

Note
  Parameter 'pcktType' must be a compile time constant.
  A packet with nested headers has a number of headers at the beginning (instead of the usual single header). For every level of header nesting, the number of possible destinations is multiplied by 32, thus for a two-nested header approach, the number of destinations is already 1024.

## ◆ put_ms_packet_header() [2/2]

void put_ms_packet_header | ( | unsigned | dstID,
|  | unsigned | pcktType )

Generate a packet header and write to it to the output stream port.

Parameters

  dstID | unsigned 5 bit (LSB). Identifies the destination of the packet. Should be unique amongst all streams it shares ports with. Can be 32 destinations or more with nested headers.
  pcktType | unsigned 3 bit (LSB). Can be used to distinguish packets with the same source and destination. Control packets set this to 7 if there is an error. This must be a compile time constant.

This intrinsic takes a destination ID and a packet type and returns a packet header.

Note
  Parameter 'pcktType' must be a compile time constant.
  A packet with nested headers has a number of headers at the beginning (instead of the usual single header). For every level of header nesting, the number of possible destinations is multiplied by 32, thus for a two-nested header approach, the number of destinations is already 1024.